Subject: Re: linux-next: manual merge of the char-misc tree with the driver-core tree

From: Jean-Philippe Brucker <[email-masked]>
Date: Tue, 2 Jul 2019 15:18:03 +0100

Hi,

[Adding Joerg]

On Mon, Jul 01, 2019 at 09:04:18PM +0100, Nathan Chancellor wrote:
> On Mon, Jul 01, 2019 at 07:09:40PM +1000, Stephen Rothwell wrote:
> > Hi all,
> > 
> > Today's linux-next merge of the char-misc tree got a conflict in:
> > 
> >   drivers/hwtracing/coresight/of_coresight.c
> > 
> > between commit:
> > 
> >   418e3ea157ef ("bus_find_device: Unify the match callback with class_find_device")
> > 
> > from the driver-core tree and commits:
> > 
> >   22aa495a6477 ("coresight: Rename of_coresight to coresight-platform")
> >   20961aea982e ("coresight: platform: Use fwnode handle for device search")
> > 
> > from the char-misc tree.
> > 
> > I fixed it up (I removed the file and added the following merge fix patch)
> > and can carry the fix as necessary. This is now fixed as far as linux-next
> > is concerned, but any non trivial conflicts should be mentioned to your
> > upstream maintainer when your tree is submitted for merging.  You may
> > also want to consider cooperating with the maintainer of the conflicting
> > tree to minimise any particularly complex conflicts.
> > 
> > From: Stephen Rothwell <[email-masked]>
> > Date: Mon, 1 Jul 2019 19:07:20 +1000
> > Subject: [PATCH] coresight: fix for "bus_find_device: Unify the match callback
> >  with class_find_device"
> > 
> > Signed-off-by: Stephen Rothwell <[email-masked]>
> > ---
> >  drivers/hwtracing/coresight/coresight-platform.c | 2 +-
> >  1 file changed, 1 insertion(+), 1 deletion(-)
> > 
> > diff --git a/drivers/hwtracing/coresight/coresight-platform.c b/drivers/hwtracing/coresight/coresight-platform.c
> > index 3c5ceda8db24..fc67f6ae0b3e 100644
> > --- a/drivers/hwtracing/coresight/coresight-platform.c
> > +++ b/drivers/hwtracing/coresight/coresight-platform.c
> > @@ -37,7 +37,7 @@ static int coresight_alloc_conns(struct device *dev,
> >  	return 0;
> >  }
> >  
> > -int coresight_device_fwnode_match(struct device *dev, void *fwnode)
> > +int coresight_device_fwnode_match(struct device *dev, const void *fwnode)
> >  {
> >  	return dev_fwnode(dev) == fwnode;
> >  }
> > -- 
> > 2.20.1
> > 
> > -- 
> > Cheers,
> > Stephen Rothwell
> 
> Hi Stephen and Michael,
> 
> It looks like a similar fix is needed for the vhost tree because of
> commit edcd69ab9a32 ("iommu: Add virtio-iommu driver") interacting with
> commit 92ce7e83b4e5 ("driver_find_device: Unify the match function with
> class_find_device()") in the driver-core tree (my patch is attached).

Nathan, thanks for noticing and fixing this.

Joerg, the virtio-iommu driver build failed in next because of a
dependency on driver-core changes for v5.3. I'm not sure what the best
practice is in this case, I guess I will resend the driver as applied
onto the latest driver-core, to have it working in v5.3?

Thanks,
Jean

> From 347a1bbeb8ba757648ceeed1839df101417a3d9f Mon Sep 17 00:00:00 2001
> From: Nathan Chancellor <[email-masked]>
> Date: Mon, 1 Jul 2019 12:54:28 -0700
> Subject: [PATCH] iommu/virtio: Constify data parameter in viommu_match_node
> 
> After commit 92ce7e83b4e5 ("driver_find_device: Unify the match
> function with class_find_device()") in the driver-core tree.
> 
> Signed-off-by: Nathan Chancellor <[email-masked]>
> ---
>  drivers/iommu/virtio-iommu.c | 2 +-
>  1 file changed, 1 insertion(+), 1 deletion(-)
> 
> diff --git a/drivers/iommu/virtio-iommu.c b/drivers/iommu/virtio-iommu.c
> index 4620dd221ffd..433f4d2ee956 100644
> --- a/drivers/iommu/virtio-iommu.c
> +++ b/drivers/iommu/virtio-iommu.c
> @@ -839,7 +839,7 @@ static void viommu_put_resv_regions(struct device *dev, struct list_head *head)
>  static struct iommu_ops viommu_ops;
>  static struct virtio_driver virtio_iommu_drv;
>  
> -static int viommu_match_node(struct device *dev, void *data)
> +static int viommu_match_node(struct device *dev, const void *data)
>  {
>  	return dev->parent->fwnode == data;
>  }
> -- 
> 2.22.0
>